<template>
<div class="flex flex-col justify-end w-full md:w-132 lg:w-144 h-full">
    <div v-if="selectedReport" class="overflow-x-auto bg-white flex-grow">
        <div class="w-full min-w-full h-full overflow-hidden">
            <table class="relative w-full h-full flex flex-col">
                <thead>
                <tr class="flex flex-row h-full items-center">
                    <th class="px-4 py-2 border-b border-gray-200 bg-gray-50 text-left text-xs leading-4 font-medium text-gray-500 uppercase tracking-wider">Id</th>
                    <th class="px-4 py-2 border-b border-gray-200 bg-gray-50 text-left text-xs leading-4 font-medium text-gray-500 uppercase tracking-wider flex-grow flex flex-row" v-if="columns.includes('Area')">
                        <button class="text-gray-500 hover:text-gray-700 bg-transparent font-bold px-1 rounded" v-on:click="load()">
                            <img svg-inline src="./pix/zond/reload.svg" alt="" class="w-6 h-6 fill-current" />
                        </button>
                    </th>
                    <th class="px-4 py-2 border-b border-gray-200 bg-gray-50 text-left text-xs leading-4 font-medium text-gray-500 uppercase tracking-wider" v-if="columns.includes('Time')">Time</th>
                    <th class="px-4 py-2 border-b border-gray-200 bg-gray-50 text-left text-xs leading-4 font-medium text-gray-500 uppercase tracking-wider flex flex-row justify-end text-right">
                        <button class="font-bold px-1 rounded float-right" v-on:click="close()" :class="[reportPalette(selectedReport.type.id).regular.text, reportPalette(selectedReport.type.id).darker.hover]">
                            <img svg-inline src="./pix/zond/close-solid.svg" class="w-6 h-6 fill-current" />
                        </button>
                    </th>
                </tr>
                </thead>
                <tbody class="bg-white overflow-y-auto">
                    <tr class="flex flex-row">
                        <td class="px-4 py-2 whitespace-no-wrap">
                            <div class="flex items-center">
                                <div class="flex-shrink-0 h-10 w-10">
                                    <img svg-inline src="./pix/virus-green.svg" class="w-full h-full" />
                                </div>
                                <div class="ml-4" v-if="columns.includes('Id')">
                                    <span class="text-sm leading-5 font-medium text-gray-900 mr-1">{{selectedReport.id}}</span>
                                </div>
                            </div>
                        </td>
                        <td class="px-4 py-2 whitespace-no-wrap flex-grow w-full">
                            <div class="text-sm leading-5 text-gray-900 whitespace-pre-line w-full">{{selectedReport.aoi.replace(/\$\d+\s*/, '')}}</div>
                            <ul class="">
                                <li class="list-none float-left mr-1" v-for="(value, key) in selectedReport.properties" :key="key" v-if="value.length && !ignored.includes(key)">
                                    <div class="tag text-xs inline-block flex flex-row mt-1" :class="[reportPalette(selectedReport.type.id).darker.text]">
                                        <span class="key px-2 rounded-l-full capitalize" :class="[reportPalette(selectedReport.type.id).regular.bg, reportPalette(selectedReport.type.id).lighter.text]">{{key}}</span>
                                        <span class="value px-2 -ml-1 rounded-r-full truncate flex-grow" :class="[reportPalette(selectedReport.type.id).light.bg]" style="max-width: 300px" v-html="value" v-linkified></span>
                                    </div>
                                </li>
                            </ul>
                        </td>
                        <td class="px-4 py-2 whitespace-no-wrap" v-if="columns.includes('Time')">
                            <div class="text-sm leading-5 text-gray-900" v-tooltip="'Time of Interest'">{{selectedReport.toi}}</div>
                            <div class="text-xs leading-5 text-gray-500" v-tooltip="'Created'">{{selectedReport.created}}</div>
                        </td>
                        <td class="px-4 py-2 whitespace-no-wrap text-sm leading-5 text-gray-500">
                            <button v-if="editable" class="text-indigo-500 hover:text-indigo-700 bg-transparent font-bold py-2 px-1 rounded inline-flex items-center" v-on:click="edit">
                                <img svg-inline src="./pix/zond/edit-pencil.svg" class="w-4 h-4 fill-current" />
                            </button>
                            <button class="font-bold py-1 px-2 rounded inline-flex items-center rounded-l-lg rounded-r-lg" v-on:click="locate"  :class="[reportPalette(selectedReport.type.id).lightest.bg, reportPalette(selectedReport.type.id).regular.text, reportPalette(selectedReport.type.id).darker.hover]">
                                <img svg-inline src="./pix/zond/location.svg" class="w-5 h-5 fill-current mt-1 mr-1" />
                                <span class="inline-block text-xs text-teal-600">{{selectedReport.places}}</span>
                            </button>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
        <div v-if="editable" v-show="editing" class="">
            <wee-spatial-report-editor :report="selectedReport" :project="selectedReport.project" :cancel="cancel" v-on:added="reload()" v-on:updated="reload()" v-on:removed="reload()" :universe="universe" :common="common"></wee-spatial-report-editor>
        </div>
        <div v-show="locating" class="">
            <wee-spatial-location-editor :editable="editable" :report="selectedReport" :cancel="cancel" ref="locator" v-on:go="go" v-on:search="search" v-on:capture="capture" v-on:hide="hide" v-on:placed="placed" v-on:replaced="replaced" v-on:deplaced="deplaced"></wee-spatial-location-editor>
        </div>
    </div>
</div>
</template>
<script>
    import Vue from 'vue'
    import vSelect from 'vue-select'
    import axios from 'axios'
    import axiosCancel from 'axios-cancel';
    import VCalendar from 'v-calendar';
    import VTooltip from 'v-tooltip'
    import WeeSpatialReportEditor from './WeeSpatialReportEditor'
    import WeeSpatialLocationEditor from './WeeSpatialLocationEditor'
    import {ThemeMixin} from './themes.js';
    
    const DB_WB_DISTRICTS =  [{"value":"AD","label":"Alipurduar"},{"value":"BN","label":"Bankura"},{"value":"BR","label":"Paschim Bardhaman"},{"value":"BR","label":"Purba Bardhaman"},{"value":"BI","label":"Birbhum"},{"value":"KB","label":"Cooch Behar"},{"value":"DA","label":"Darjeeling"},{"value":"UD","label":"Uttar Dinajpur"},{"value":"DD","label":"Dakshin Dinajpur"},{"value":"HG","label":"Hooghly"},{"value":"HR","label":"Howrah"},{"value":"JP","label":"Jalpaiguri"},{"value":"JH","label":"Jhargram"},{"value":"KO","label":"Kolkata"},{"value":"KA","label":"Kalimpong"},{"value":"MA","label":"Malda"},{"value":"ME","label":"Paschim Medinipur"},{"value":"ME","label":"Purba Medinipur"},{"value":"MU","label":"Murshidabad"},{"value":"NA","label":"Nadia"},{"value":"PN","label":"North 24 Parganas"},{"value":"PS","label":"South 24 Parganas"},{"value":"PU","label":"Purulia"}];;
    
    Vue.component('v-select', vSelect);
    Vue.use(VCalendar);
    Vue.use(VTooltip)

    axiosCancel(axios, {
        debug: false // default
    });
    
    export default{
        name: "WeeSpatialReportViewer",
        props: {
            editable: {
                type: Boolean,
                default: false
            },
            report: {
                type: [Number, Object],
                default: null
            },
            ignored: {
                type: Object,
                default: ['country', 'state']
            },
            columns: {
                type: Array,
                default: ['Area']
            },
            theme: {
                type: String,
                default: 'teal'
            },
            universe: {
                type: Array,
                default: []
            },
            common: {
                type: Array,
                default: []
            }
        },
        mixins: [ThemeMixin],
        components: {
            WeeSpatialReportEditor,
            WeeSpatialLocationEditor
        },
        data(){
            return {
                editing:  false,
                locating: false,
                selectedReport: (typeof this.report == 'object') ? this.report : null
            };
        },
        created(){
            if(typeof this.report != 'object'){
                this.load();
            }
        },
        watch: {
            report(n, o){
                if(n && typeof n != 'object'){
                    this.load();
                }
            }
        },
        methods: {
            load(){
                let self = this;
                axios.get(this.reportUrl).then(function(response){
                    if(response.data.report){
                        self.selectedReport = response.data.report;
                    }
                }).catch(function(error){
                    console.log(error);
                });
            },
            reload(){
                this.load();
            },
            resetState(){
                this.editing  = false;
                this.locating = false;
            },
            edit(){
                this.resetState();
                this.editing = true;
                this.selectedReport = this.selectedReport;
            },
            locate(){
                this.resetState();
                this.locating = true;
                this.selectedReport = this.selectedReport;
            },
            cancel(){
                this.resetState();
            },
            go(coordinate){
                this.$emit('go', coordinate);
            },
            search(place){
                this.$emit('search', place);
            },
            capture(mode, id){
                this.$emit('capture', mode, id);
            },
            captured(){
                this.$refs.locator.captured();
            },
            close(){
                this.$emit('close');
            },
            placed(id){
                console.log("captured placed", id);
                this.$emit('placed', id);
                this.load();
            },
            replaced(id){
                this.$emit('replaced', id);
            },
            deplaced(id){
                console.log('ReportViewer::deplaced', id);
                this.$emit('deplaced', id);
                this.load();
            },
            selected(selection){
                if(this.selectedReport){
                    this.$refs.locator.selected(selection);
                }
            }
        },
        computed: {
            reportUrl(){
                const reportId = (typeof this.report == 'object') ? this.report.id : this.report;
                return "/reports/"+reportId;
            }
        }
    }
</script>
<style scoped>

</style>
